import ApiGameService from '../services/ApiGameService';
import {
  PUBLIC_STATE_CREATED,
  PUBLIC_STATES_LOADED
} from './types';

export const createPublicState = (requestData, onSuccess, onError) => dispatch => {
  const service = new ApiGameService();
  const scb = (data) => {
    dispatch({
      type: PUBLIC_STATE_CREATED,
      data: data
    });
    if (onSuccess) onSuccess(data);
  };
  const ecb = (error) => {
    if (onError) onError(error);
  };
  service.createPublicState(requestData, scb, ecb);
};

export const loadPublicStates = (onSuccess, onError) => dispatch => {
  const service = new ApiGameService();
  const scb = (data) => {
    dispatch({
      type: PUBLIC_STATES_LOADED,
      data: data
    });
    if (onSuccess) onSuccess(data);
  };
  const ecb = (error) => {
    if (onError) onError(error);
  };
  service.getPublicStates(scb, ecb);
};
