import React, { Component } from 'react';
import PropTypes from 'prop-types';
import { loadPublicStates } from '../../actions/gameActions';
import { connect } from 'react-redux';
import { Link } from 'react-router-dom';

class PublicStateList extends Component {

  componentDidMount() {
    this.props.loadPublicStates();
  };

  render() {

    const pubStateList = this.props.publicStates.map((ps) => {
      return (
        <div key={ps.id}>
          <Link to={"/state/" + ps.name}>
            {ps.name}
          </Link>
        </div>
      )
    });

    return (
      <div>
        <h1>PublicStateList</h1>
        {pubStateList}
      </div>
    )
  }
};

PublicStateList.propTypes = {
  loadPublicStates: PropTypes.func.isRequired,
  publicStates: PropTypes.array,
};

const mapStateToProps = state => ({
  publicStates: state.adminData.publicStates
});

export default connect(mapStateToProps, { loadPublicStates })(PublicStateList);
